// 04_1.c - KEXEW_@̃vO

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define	N	3		// Ǎ
#define TOL	1.0e-6	// 0l

void PrintMatrix2D(double M[][N + 1], int m, int n);
void SwitchMaxRow(double M[N][N + 1], int pivot);

int main()
{
	int k, i, j, J;
	double A[N][N + 1] = {
		{ 2, 2, -4, -5 },
		{ 6, 1, 1, 2 },
		{ 3, 4, 0, -4 }
	};				//	gWs
	double pivot;	//	Ίp
	double c;		//	|ovZp̌W

	printf("-----KEXEW_@-----\n");
	printf("A | b = \n");
	PrintMatrix2D(A, 3, 4);

	// |oɂWsΊp
	for (k = 0; k < N; k++)
	{
		// sւ
		SwitchMaxRow(A, k);

		if (fabs(A[k][k]) < TOL)
		{
			printf("Ӊ𖳂\n");
			exit(1);
		}
		pivot = A[k][k];

		// ΊpŏZ
		for (j = k; j < N + 1; j++) A[k][j] /= pivot;

		// ̍s̓񐬕0ɂ
		for (i = 0; i < N; i++)
		{
			if (i == k) continue;

			c = A[i][k];
			for (j = k; j < N + 1; j++) A[i][j] -= c * A[k][j];
		}
	}

	printf(":\n");
	for (k = 0; k < N; k++) printf("\tx_%d = %10.6lf\n", k + 1, A[k][N]);

	return 0;
}


//--------------------------------------------------
//  y@\z m~nsidouble^j\o͂
//  yz A: Ώۂ̍s, m: s, n: 
//  y߂lz 
//--------------------------------------------------
void PrintMatrix2D(double M[][N + 1], int m, int n)
{
	int k;
	int j;

	for (k = 0; k < m; k++)
	{
		for (j = 0; j < n; j++)
		{
			printf("\t%lf", M[k][j]);
		}
		printf("\n");
	}
}


//----------------------------------------------------------------------------
//  y@\z ŝΊpɂāCŐΒlő̍sƓւ
//  yz M: Ώۂ̍s, pivot: ΊpID
//  y߂lz 
//----------------------------------------------------------------------------
void SwitchMaxRow(double M[N][N + 1], int pivot)
{
	int	k;
	int max;
	double tmp;

	max = pivot;

	// Βlő̍sT
	for (k = pivot + 1; k < N; k++)
	{
		if (fabs(M[k][pivot]) > fabs(M[max][pivot])) max = k;
	}
	if (max == pivot) return;

	// sւ
	for (k = pivot; k < N + 1; k++)
	{
		tmp = M[pivot][k];
		M[pivot][k] = M[max][k];
		M[max][k] = tmp;
	}
}