// 04_2.c - LŨvO(KEX̏@, Doolittle@)

#include <stdio.h>
#include <math.h>

#define	N	3		// s̎
#define TOL	1.0e-6	// 0l

void PrintMatrixD(double M[N][N]);
void PrintLUMatrixD(double M[N][N]);

int main()
{
	int i, j, k, t;
	double A[N][N] = {
		{ 2, 4, -10 },
		{ 1, 6, 7 },
		{ 3, 5, -13 }
	};	// s
	double tmp;

	printf("-----LU-----\n");
	printf("A = LU = \n");
	PrintMatrixD(A);

	// Ls̑1vZ
	for (i = 1; i < N; i++) A[i][0] /= A[0][0];

	for (k = 1; k < N; k++)
	{
		// Us̍svZ
		for (j = k; j < N; j++)
		{
			tmp = 0.0;
			for (t = 0; t < k; t++) tmp += A[k][t] * A[t][j];
			A[k][j] -= tmp;
		}

		// Ls̗vZ
		for (i = k + 1; i < N; i++)
		{
			tmp = 0.0;
			for (t = 0; t < k; t++) tmp += A[i][t] * A[t][k];
			A[i][k] = (A[i][k] - tmp) / A[k][k];
		}
	}

	PrintLUMatrixD(A);

	return 0;
}


//--------------------------------------------------
//  y@\z N~Nsidouble^j\o͂
//  yz M: Ώۂ̍s
//  y߂lz PrintMatrixD
//--------------------------------------------------
void PrintMatrixD(double M[N][N])
{
	int i;
	int j;

	for (i = 0; i < N; i++)
	{
		for (j = 0; j < N; j++)
		{
			printf("\t%lf", M[i][j]);
		}
		printf("\n");
	}
}


//------------------------------------------------------------
//  y@\z LUN~Nsidouble^j\o͂
//  yz M: Ώۂ̍s
//  y߂lz 
//------------------------------------------------------------
void PrintLUMatrixD(double M[N][N])
{
	int i;
	int j;

	// Ls\
	printf("L = \n");
	for (i = 0; i < N; i++)
	{
		for (j = 0; j < i; j++) printf("\t%lf", M[i][j]);
		printf("\t%lf", 1.0);
		for (j = i + 1; j < N; j++) printf("\t%lf", 0.0);
		printf("\n");
	}

	// Us\
	printf("\nU = \n");
	for (i = 0; i < N; i++)
	{
		for (j = 0; j < i; j++) printf("\t%lf", 0.0);
		for (j = i; j < N; j++) printf("\t%lf", M[i][j]);
		printf("\n");
	}
}