// 05_3.c - Ώ̍šŗLl, ŗLxNg߂vOiRr@j

#include <stdio.h>
#include <math.h>

#define TOL 1.0e-6	// e덷
#define N 3			// s̎
#define ITE 100		// őJԂ

int EigenJacobi(double M[N][N]);
int DetSymmetry(double M[N][N]);
void MaxNonDiagID(double M[N][N], int *row, int *col);
void SetGivensMatrix(double G[N][N], int row, int col, double sine, double cosine);
void MulMatrixD(double Ans[N][N], double M1[N][N], double M2[N][N]);
void TransposeMatrix(double matrix[N][N]);
int DetConv(double M[N][N]);
void CopyMatrix(double M1[N][N], double M2[N][N]);
void PrintMatrixD(double M[N][N]);

void main()
{
	int i, ret;
	double A[N][N] = {
		{ 3, 2, 2 },
		{ 2, 2, 0 },
		{ 2, 0, 4 }
	};	// Ώۍs A

	printf("-----ŗLl, ŗLxNg-----\n");
	// ŗLl, ŗLxNg߂
	ret = EigenJacobi(A);
	if (ret < 0)
	{
		printf("vZs\n");
		if (ret == -1) printf("\n");
		else			printf("Ώ̍s\n");
		return;
	}
}


//---------------------------------------------------------------------
//  y@\z Ώ̍šŗLl, ŗLxNg߂
//  yz M: Ώۂ̍s
//  y߂lz tO(1: vZ, -1: s, -2: s񂪔Ώ)
//---------------------------------------------------------------------
int EigenJacobi(double M[N][N])
{
	int i, j, k;
	int row, col;			// Βlő̔Ίpvf̍sID, ID
	double X[N][N];			// JԂvZp̍s X
	double T[N][N];			// MuX]s G  ts G^(-1)
	double Tmp[N][N];		// vZps
	double E[N][N] = {
		{ 1, 0, 0 },
		{ 0, 1, 0 },
		{ 0, 0, 1 }
	};						// ŗLxNg
	double EV[N][N];		// ŗLl
	double t, tm;			// MuX]pɊÂ^WFg
	double a, b, c;			// tangent߂2̌W
	double sine, cosine;	// MuX]pɊÂTC, RTC

	// s̑Ώ̐𔻒肷
	if (!DetSymmetry(M)) return -2;

	// X
	for (i = 0; i < N; i++) for (j = 0; j < N; j++) X[i][j] = M[i][j];

	// JԂvZ
	for (k = 0; k < ITE; k++)
	{
		// Βlő̔Ίpvf̍sEID𒲂ׂ
		MaxNonDiagID(X, &row, &col);

		// ^WFg߂
		a = X[row][col];
		b = X[row][row] - X[col][col];
		c = -a;
		t = (-b + sqrt(b*b - 4.0 * a*c)) / (2.0 * a);
		tm = (-b - sqrt(b*b - 4.0 * a*c)) / (2.0 * a);
		if (fabs(t) > fabs(tm)) t = tm;
		
		

		// TC, RTC߂
		cosine = 1 / (sqrt(1 + t*t));  // ɐƂ
		sine = cosine * t;
		
		// Lł͌vZԁEx̂߁Ctan̔{p̌C2
		// ̉̌ptan߁Csincos߂ĂD

		// MuX]sݒ肷
		SetGivensMatrix(T, row, col, sine, cosine);

		// ŗLxNg߂
		MulMatrixD(Tmp, E, T);
		CopyMatrix(Tmp, E);

		// ϊ : G^(-1)XG ߂
		MulMatrixD(Tmp, X, T);
		TransposeMatrix(T);
		MulMatrixD(EV, T, Tmp);

		// vZʂꍇ
		if (DetConv(EV) == 1)
		{
			printf(",  = %d\n", k+1);
			printf("ŗLl = \n");
			for (i = 0; i < N; i++) printf("\t%lf", EV[i][i]);
			printf("\n");
			printf("ŗLxNg = \n");
			PrintMatrixD(E);

			return 1;
		}

		// JԂvZp̍sɌʂʂ
		CopyMatrix(EV, X);
	}

	// ̏ꍇ
	return -1;
}


//-----------------------------------------
//  y@\z s̑Ώ̐𔻒肷
//  yz M: Ώۂ̍s
//  y߂lz 茋(0: Ώ, 1: Ώ)
//-----------------------------------------
int DetSymmetry(double M[N][N])
{
	int i, j;

	for (i = 0; i < N; i++)
	{
		for (j = i + 1; j < N; j++)
		{
			// Ώ̂̏ꍇ
			if (M[i][j] != M[j][i]) return 0;
		}
	}

	return 1;
}


//----------------------------------------------------------------------------------
//  y@\z N~NΏ̍sɂāCΒlő̔Ίpvf̍sEID𒲂ׂ
//  yz M: Ώۂ̍s, row: sID, col: ID
//  y߂lz 
//----------------------------------------------------------------------------------
void MaxNonDiagID(double M[N][N], int *row, int *col)
{
	int i, j;
	double max = 0.0;

	// ID
	*row = 0;
	*col = 1;

	for (i = 0; i < N ; i++)
	{
		for (j = 0; j < N; j++)
		{
			if (i == j) continue;

			if (max < fabs(M[i][j]))
			{
				max = fabs(M[i][j]);
				*row = i;
				*col = j;
			}
		}
	}
}


//--------------------------------------------------------------
//  y@\z MuX]sݒ肷
//  yz G: MuX]s, row: sID, col: ID, 
//           sine: TC, cosine: RTC
//  y߂lz 
//--------------------------------------------------------------
void SetGivensMatrix(double G[N][N], int row, int col, double sine, double cosine)
{
	int i, j;

	for (i = 0; i < N; i++)
	{
		for (j = 0; j < N; j++)
		{
			// Ίpvf̏ꍇ
			if (i == j)	G[i][j] = 1.0;
			// Ίpvf̏ꍇ
			else G[i][j] = 0.0;
		}
	}

	G[row][row] = G[col][col] = cosine;
	G[col][row] = sine;
	G[row][col] = -sine;
}


//---------------------------------------------------------------------
//  y@\z N~Nsidouble^j M1,M2̏Z(M1*M2)̌ʂ߂
//  yz Ans: Z, M1: Ώۂ̍s1, M2: Ώۂ̍s2
//  y߂lz 
//---------------------------------------------------------------------
void MulMatrixD(double Ans[N][N], double M1[N][N], double M2[N][N])
{
	int i, j, k;
	double tmp;

	for (i = 0; i < N; i++)
	{
		for (j = 0; j < N; j++)
		{
			tmp = 0;
			for (k = 0; k < N; k++)
			{
				tmp += M1[i][k] * M2[k][j];
			}
			Ans[i][j] = tmp;
		}
	}
}


//------------------------------------------
//  y@\z N~Ns̓]us߂
//  yz T: ]us, M: Ώۂ̍s
//  y߂lz 
//------------------------------------------
void TransposeMatrix(double matrix[N][N])
{
	int i, j;
	double tmp;

	for (i = 0; i < N - 1; i++)
	{
		for (j = i + 1; j < N; j++)
		{
			tmp = matrix[i][j];
			matrix[i][j] = matrix[j][i];
			matrix[j][i] = tmp;
		}
	}
}


//------------------------------------------------
//  y@\z JԂvZʂ̎𔻒肷
//  yz M: vZʂ̍s
//  y߂lz 茋(0: , 1: )
//------------------------------------------------
int DetConv(double M[N][N])
{
	int i, j;

	// SĂ̔Ίpvfe덷菬
	for (i = 0; i < N; i++)
	{
		for (j = 0; j < N; j++)
		{
			// ΊpvfXLbv
			if (i == j) continue;

			if (fabs(M[i][j]) > TOL) return 0;
		}
	}

	return 1;
}


//------------------------------------------------
//  y@\z N~Ns̗vfʂ̍sɎʂ
//  yz M1: Ώ̂̍s, M2: ʐ̍s
//  y߂lz 
//------------------------------------------------
void CopyMatrix(double M1[N][N], double M2[N][N])
{
	int i, j;

	for (i = 0; i < N; i++)
	{
		for (j = 0; j < N; j++)
		{
			M2[i][j] = M1[i][j];
		}
	}
}


//--------------------------------------------------
//  y@\z N~Nsidouble^j\o͂
//  yz M: Ώۂ̍s
//  y߂lz 
//--------------------------------------------------
void PrintMatrixD(double M[N][N])
{
	int i;
	int j;

	for (i = 0; i < N; i++)
	{
		for (j = 0; j < N; j++)
		{
			printf("\t%lf", M[i][j]);
		}
		printf("\n");
	}
}