// 08_2.c - QENb^@ƃIC[@rvO

#include <stdio.h>
#include <math.h>

void euler_error(FILE *fp, double x0, double y0, double xn, double h);
void runge_error(FILE *fp, double x0, double y0, double xn, double h);

int main()
{
	FILE *fp;       // o̓t@C̃|C^
	double x0, y0;  // Ɨϐ̏l, ]ϐ̏l
	double xn;      // ߂x̋Ԃ̏I_
	double x;       // o͂Ɨϐ
	double h;       // ݕ
	char zz;

	// o̓t@CJ
	if ((fp = fopen("08_2_result.txt", "w")) == NULL)
	{
		printf(">> t@Co͕s\n");
		return 1;
	}

	printf("-----QENb^@ƃIC[@rvO-----\n");

	while (1)
	{
		printf("x̏l x0 = ");
		scanf("%lf%c", &x0, &zz);
		break;
	}
	while (1)
	{
		printf("y̏l y0 = ");
		scanf("%lf%c", &y0, &zz);
		break;
	}
	while (1)
	{
		printf("x̋Ԃ̏I_ xn = ");
		scanf("%lf%c", &xn, &zz);
		if (xn <= x0)  continue;
		break;
	}
	while (1)
	{
		printf("ݕ h = ");
		scanf("%lf%c", &h, &zz);
		break;
	}

	// xW̏o
	fprintf(fp, "xW\nx =\n");
	x = x0;
	while (x < xn)
	{
		fprintf(fp, "%.1f\n", x);
		x += h;
	}
	fprintf(fp, "%.1f\n\n", x);

	// IC[@ɊÂߎ̌덷߂
	euler_error(fp, x0, y0, xn, h);
	fprintf(fp, "\n");

	// QENb^@ɊÂߎ̌덷߂
	runge_error(fp, x0, y0, xn, h);

	printf("\nvZI\n");

	fclose(fp);
    return 0;
}


//--------------------------------------------
//  y@\z ƂȂϕ萔߂
//  yz x0, y0: ϐ̏l
//  y߂lz vZ
//--------------------------------------------
double func_const(double x0, double y0)
{
	return y0 / exp(2.0 * x0 * x0);
}


//----------------------------------------
//  y@\z ]ϐ̒l߂
//  yz x: Ɨϐ, C: ϕ萔
//  y߂lz vZ
//----------------------------------------
double func(double x, double C)
{
	return C * exp(2.0 * x * x);
}


//----------------------------------------
//  y@\z ̒l߂
//  yz x: Ɨϐ, y: ]ϐ
//  y߂lz vZ
//----------------------------------------
double dfunc(double x, double y)
{
	return 4 * x * y;
}


//-----------------------------------------------------------
//  y@\z IC[@ɊÂߎ̌덷߂
//  yz fp: o̓t@C, 
//           x0, y0: Ɨϐ̏l, ]ϐ̏l, 
//           xn: ߂x̋Ԃ̏I_, h: ݕ
//  y߂lz 
//-----------------------------------------------------------
void euler_error(FILE *fp, double x0, double y0, double xn, double h)
{
	double x, y;  // Ɨϐ, ߎ
	double C;     // ƂȂϕ萔
	double yy;    // ^l
	double e;     // 덷

	// ƂȂϕ萔߂
	C = func_const(x0, y0);

	// 
	x = x0;
	yy = y = y0;
	e = 0.0;

	// 덷t@Cɏo͂
	fprintf(fp, "IC[@̌덷\nEe =\n");
	fprintf(fp, "%lf\n", e);
	for (; x < xn;)
	{
		// ߎ߂
		y += dfunc(x, y) * h;

		// ^l߂
		x = x + h;
		yy = func(x, C);

		// 덷߂
		e = fabs(yy - y);

		fprintf(fp, "%lf\n", e);
	}
}


//------------------------------------------------------------
//  y@\z QENb^@ɊÂߎ̌덷߂
//  yz fp: o̓t@C, 
//           x0, y0: Ɨϐ̏l, ]ϐ̏l, 
//           xn: ߂x̋Ԃ̏I_, h: ݕ
//  y߂lz 
//------------------------------------------------------------
void runge_error(FILE *fp, double x0, double y0, double xn, double h)
{
	double x, y;            // Ɨϐ, ߎ
	double C;               // ƂȂϕ萔
	double yy;              // ^l
	double e;               // 덷
	double g1, g2, g3, g4;  // Ȑ̌X

	// ƂȂϕ萔߂
	C = func_const(x0, y0);

	// 
	x = x0;
	yy = y = y0;
	e = 0.0;

	// 덷t@Cɏo͂
	fprintf(fp, "QENb^@̌덷\nEr =\n");
	fprintf(fp, "%lf\n", e);
	for (; x < xn;)
	{
		// Ȑ̌X߂
		g1 = dfunc(x, y);
		g2 = dfunc(x + h / 2, y + g1 * h / 2);
		g3 = dfunc(x + h / 2, y + g2 * h / 2);
		g4 = dfunc(x + h, y + g3 * h);

		// ߎ߂
		y += (g1 + g2 * 2 + g3 * 2 + g4) * h / 6;

		// ^l߂
		x = x + h;
		yy = func(x, C);

		// 덷߂
		e = fabs(yy - y);

		fprintf(fp, "%lf\n", e);
	}
}