// 09_2.c - olE}XE_pn̓߂vOiS{N[Cj

#include <stdio.h>
#include <math.h>

#define TOL 1.0e-6	// e덷

typedef void(*dfuncP)(double x, double z[2], double p[3], double f[2]);

void dfunc1(double x, double z[2], double p[3], double f[2]);
void dfunc2(double x, double z[2], double p[3], double f[2]);
void rungeP(FILE *fp, dfuncP dfp, double x0, double z0[2], double xn, double p[3], double h);

int main()
{
	FILE *fp;               // o̓t@C̃|C^
	double t0, z0[2];       // Ɨϐ̏l[s], ]ϐ0,1K̏l[m],[m/s]
	double tn;              // ߂t̋Ԃ̏I_[s]
	double t;
	double cc;              // ՊEW[Ns/m]
	double Fc;              // N[C[N]
	double p[3];            // p[^{m[kg],c[Ns/m],k[N/m]} or {m,Fc,k}
	double h;               // ݕ[s]
	const double cr = 0.15;  // c/cc
	char zz;

	// 
	t0 = 0.0;
	z0[0] = 5.0;
	z0[1] = 0.0;
	tn = 20.0;
	p[0] = 1.0;                  // m
	p[2] = 1.0;                  // k
	cc = 2 * sqrt(p[0] * p[2]);
	p[1] = cr * cc;              // c
	h = 0.2;

	// o̓t@CJ
	if ((fp = fopen("09_2_result.txt", "w")) == NULL)
	{
		printf(">> t@Co͕s\n");
		return 1;
	}

	printf("-----olE}XE_pn̓߂vOiS{N[Cj-----\n");

	printf("Fc = ");
	scanf("%lf%c", &Fc, &zz);

	t = t0;
	fprintf(fp, "\nt=\n%lf\n", t);
	while (1)
	{
		t = t + h;
		fprintf(fp, "%lf\n", t);

		if (fabs(t - tn) < TOL) break;
	}

	// QENb^@ɊÂߎ߂
	// S
	fprintf(fp, "\nc/cc=\n%lf\n", cr);
	rungeP(fp, dfunc1, t0, z0, tn, p, h);
	// N[C
	p[1] = Fc;
	fprintf(fp, "\nFc=\n%lf\n", p[1]);
	rungeP(fp, dfunc2, t0, z0, tn, p, h);

	printf("\nvZI\n");

	fclose(fp);
    return 0;
}


//------------------------------------------------------
//  y@\z ̒l߂
//  yz x: Ɨϐ, z: ]ϐ0,1K, 
//           p: p[^{m,c,k}
//           f: eK̔̒l
//  y߂lz 
//------------------------------------------------------
void dfunc1(double x, double z[2], double p[3], double f[2])
{
	f[0] = z[1];
	f[1] = (z[1] * p[1] + z[0] * p[2]) * (-1) / p[0];
}


//------------------------------------------------------
//  y@\z ̒l߂
//  yz x: Ɨϐ, z: ]ϐ0,1K, 
//           p: p[^{m,Fc,k}
//           f: eK̔̒l
//  y߂lz 
//------------------------------------------------------
void dfunc2(double x, double z[2], double p[3], double f[2])
{
	f[0] = z[1];

	if (z[1] > 0.0){
		        f[1] = ( -z[0] * p[2]-p[1] ) / p[0];
	}
	else
	{
		if (z[1] == 0.0)
			f[1] =  -z[0] * p[2] / p[0];
		else
			f[1] = (- z[0] * p[2]+p[1] ) / p[0];
	}

}


//------------------------------------------------------------------------
//  y@\z QENb^@ɊÂߎ߂
//           iolE}XE_pn)
//  yz fp: o̓t@C, dfp: ̊֐|C^,
//           x0, z0: Ɨϐ̏l, ]ϐ0,1K̏l, 
//           xn: ߂x̋Ԃ̏I_, p: p[^{m,Fc,k}, h: ݕ
//  y߂lz 
//------------------------------------------------------------------------
void rungeP(FILE *fp, dfuncP dfp, double x0, double z0[2], double xn, double p[3], double h)
{
	double x;							// Ɨϐ
	double z[2];						// ]ϐ0,1K
	double Z[2];
	double g1[2], g2[2], g3[2], g4[2];	// 1,2,3,4(eC[WJ)
	int i;

	// 
	x = x0;
	for(i = 0 ; i<2 ; i++) z[i] = z0[i];

	fprintf(fp, "ʒu\nx=\n");
	fprintf(fp, "%lf\n", z[0]);
	while (1)
	{
		// QENb^@ŋߎ߂

		// 1`4߂
		dfp(x, z, p, g1);
		for (i = 0; i < 2; i++) Z[i] = z[i] + g1[i] * h / 2;
		dfp(x + h / 2, Z, p, g2);
		for (i = 0; i < 2; i++) Z[i] = z[i] + g2[i] * h / 2;
		dfp(x + h / 2, Z, p, g3);
		for (i = 0; i < 2; i++) Z[i] = z[i] + g3[i] * h;
		dfp(x + h, Z, p, g4);

		x = x + h;

		// ߎ߂
		for (i = 0; i < 2; i++) z[i] += (g1[i] + g2[i] * 2 + g3[i] * 2 + g4[i]) * h / 6.0;
		fprintf(fp, "%lf\n", z[0]);

		if (fabs(x - xn) < TOL) break;
	}
}
