// 06_2.c - ŏ@̃vO

#include <stdio.h>
#include <math.h> 

#define	N	10		// f[^_̏^Ǩ̏
#define	TOL	1.0e-6	// 0l

void SwitchMaxRow3(double M[][N + 1], int d, int pivot);
int GaussJordan(double A[][N + 1], int d);

int main()
{
	int i, j, k;
	int n;					// f[^_
	int m;					// ߎ̎
	int cnt = 0;
	double x[N], y[N];		// ʉߓ_̍W x,y
	double Ab[N][N + 1];	// K̊gWs^
	double Sx[2 * N];		// ǨWs̐
	double Sxy[N];			// KEӂ̗xNg
	double s;
	char zz;

	printf("-----ŏ@̃vO-----\n");

	while (1)
	{
		printf("f[^_ n (1<n<10): ");
		scanf("%d%c", &n, &zz);
		if ((n <= 1) || (N <= n))  continue;

		printf("\nW:\n");
		for (i = 0; i < n; i++)
		{
			printf(" x(%d): ", i);
			scanf("%lf%c", &x[i], &zz);
			printf(" y(%d): ", i);
			scanf("%lf%c", &y[i], &zz);
		}
		break;
	}

	while (1)
	{
		printf("\nߎ̎ m (1<=m<n): ");
		scanf("%d%c", &m, &zz);
		if ((m < 1) || (n <= m))  continue;
		break;
	}

	// Ws̐߂
	for (i = 0; i < (2 * m + 1); i++)
	{
		if (i == 0) Sx[i] = n;
		else
		{
			Sx[i] = 0.0;
			for (j = 0; j < n; j++)
			{
				s = 1.0;
				for (k = 0; k < i; k++) s *= x[j];
				Sx[i] += s;
			}
		}
	}

	// KEӂ̗xNg߂
	for (i = 0; i < (m + 1); i++)
	{
		Sxy[i] = 0.0;
		for (j = 0; j < n; j++)
		{
			s = y[j];
			for (k = 0; k < i; k++) s *= x[j];
			Sxy[i] += s;
		}
	}

	// gWsݒ肷
	for (i = 0; i < (m + 1); i++)
	{
		for (j = 0; j < (m + 2); j++)
		{
			if (j == m + 1) Ab[i][j] = Sxy[i];
			else Ab[i][j] = Sx[i + j];
		}
	}

	// K̉iߎ̌Wj߂
	GaussJordan(Ab, m + 1);
	printf("ߎ f(x) =");
	for (i = m; i >= 0; i--)
	{
		if (i != m && Ab[i][m] >= 0.0) printf(" +");
		else printf(" ");

		printf("%10.6lf", Ab[i][m + 1], i);
		if (i > 0) printf(" x^%d", i);
	}
	printf("\n");

    return 0;
}


//------------------------------------------------------------
//  y@\z KEXEW_@ŘẢ߂
//  yz A: gWs^, d: Ws̎
//  y߂lz 
//------------------------------------------------------------
int GaussJordan(double A[][N + 1], int d)
{
	int i, j, k;
	double pivot;	//	Ίp
	double c;		//	|ovZp̌W

	// |oɂWsΊp
	for (i = 0; i < d; i++)
	{
		// sւ
		SwitchMaxRow3(A, d, i);

		if (fabs(A[i][i]) < TOL)
		{
			printf("Ӊ𖳂\n");
			exit(1);
		}
		pivot = A[i][i];

		// ΊpŏZ
		for (j = i; j < d + 1; j++) A[i][j] /= pivot;

		// ̍s̓񐬕0ɂ
		for (j = 0; j < d; j++)
		{
			if (j == i) continue;

			c = A[j][i];
			for (k = i; k < d + 1; k++) A[j][k] -= c * A[i][k];
		}
	}

	return 0;
}


//----------------------------------------------------------------------------
//  y@\z ŝΊpɂāCŐΒlő̍sƓւ
//  yz M: Ώۂ̍s, d: s̎, pivot: ΊpID
//  y߂lz 
//----------------------------------------------------------------------------
void SwitchMaxRow3(double M[][N + 1], int d, int pivot)
{
	int	i, j;
	int max;
	double tmp;

	max = pivot;

	// Βlő̍sT
	for (i = pivot + 1; i < d; i++)
	{
		if (fabs(M[i][pivot]) > fabs(M[max][pivot])) max = i;
	}
	if (max == pivot) return;

	// sւ
	for (i = pivot; i < d + 1; i++)
	{
		tmp = M[pivot][i];
		M[pivot][i] = M[max][i];
		M[max][i] = tmp;
	}
}