% A_X@̃vO
function e083
x0 = 0;             % Ɨϐ̏l
y0 = 1;             % ]ϐ̏l
xi = 1;             % ͋Ԃ̎n_
xn = 2;             % ͋Ԃ̏I_
h = 0.1;            % ݕ
n = (xn-x0)/h;      % 
x = zeros(1,n+1);   % Ɨϐ
y = zeros(1,n+1);   % ߎ
yy = zeros(1,n+1);  % ^l

% A_X@ɊÂߎ߂
[x,y,yy] = adams(x0, y0, xn, h);

% Ot`悷
plot(x,yy,'-ob')  % ^l
hold on
plot(x,y,'-^r')  % ߎ
axis([xi,xn,min(yy),max(y)])  % ͈̔͂̐ݒ
xlabel('X')
ylabel('Y')
legend('yy','y')
end

function [x,y,yy] = adams(x0,y0,xn,h)
%   @\:
%   A_X@ɊÂߎ̌덷߂
%   x0: Ɨϐ̏l
%   y0: ]ϐ̏l
%	xn: ͋Ԃ̏I_
%   h: ݕ
%   C: ƂȂϕ萔
%   ߂l:
%	x: Ɨϐ
%   y: ߎ
%   yy: ^l

% 
x(1,1) = x0;
y(1,1) = y0;
yy(1,1) = y0;
TOL = 1.0e-6;   % e덷

% ƂȂϕ萔߂
C = func_const(x0, y0);

% ̒l߂
df = zeros(1,5);    % ̒l
df(1,1) = dfunc(x(1,1), y(1,1));

for i = 1:3
    % QENb^@ŋߎ߂
    y(1,i+1) = runge(x(1,i), y(1,i), h);
    
    x(1,i+1) = x(1,i) + h;
    
    % ^l߂
    yy(1,i+1) = func(x(1,i+1), C);
    
    % ̒l߂
    df(1,i+1) = dfunc(x(1,i+1), y(1,i+1));
end

i = i + 1;
while x(1,i) < xn
    % \q߂
    yp = y(1,i) + (55.0*df(1,4) - 59.0*df(1,3) + 37.0*df(1,2) - 9.0*df(1,1)) * h / 24.0;
    
    x(1,i+1) = x(1,i) + h;
    while 1
        df(1,5) = dfunc(x(1,i+1), yp);
        
        % Cq߂
        yc = y(1,i) + (9.0*df(1,5) + 19.0*df(1,4) - 5.0*df(1,3) + df(1,2)) * h / 24.0;
        
        % 덷߂
        if abs(yc - yp) < TOL
            y(1,i+1) = yc;
            break;
        end
        
        yp = yc;
    end
    
    % ^l߂
    yy(1,i+1) = func(x(1,i+1), C);
    
    % ̃Xebvpɗ\q̃p[^XV
    for j = 1:4
        df(j) = df(j + 1);
    end
    
    i = i + 1;
end
end

function C = func_const(x0,y0)
%   @\: ƂȂϕ萔߂
%   x0: Ɨϐ̏l
%   y0: ]ϐ̏l
%   ߂l:
%   C: ƂȂϕ萔

C = y0 / exp(2.0 * x0 * x0);
end

function Y = runge(x,y,h)
%   @\:
%   QENb^@ɊÂߎ߂
%   x: Ɨϐ
%   y: ]ϐ
%   h: ݕ
%   ߂l:
%	y: ߎ

% Ȑ̌X߂
g1 = dfunc(x, y);
g2 = dfunc(x + h / 2, y + g1 * h / 2);
g3 = dfunc(x + h / 2, y + g2 * h / 2);
g4 = dfunc(x + h, y + g3 * h);

% ߎ߂
Y = y + (g1 + g2 * 2 + g3 * 2 + g4) * h / 6.0;
end

function dy = dfunc(x,y)
%   @\: ̒l߂
%   x: Ɨϐ
%   y: ]ϐ
%   ߂l:
%   dy: ̒l

dy = 4 * x * y;
end

function y = func(x,C)
%   @\: ]ϐ̒l߂
%   x: Ɨϐ
%   C: ϕ萔
%   ߂l:
%   y: ]ϐ̒l

y = C * exp(2.0 * x * x);
end